/* $Id: code07d0.c,v 1.6 2003/04/02 03:53:08 chrisf Exp $ */

/*
 * PBJTime - Clock utility
 * Copyright (C) 2003 Chris Faherty
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <PalmOS.h>
#include "pbjtimehackRsc.h"
#include "pbjtimehack.h"

/*
 * This is the code that will be called whenever the user taps myhack's "+"
 * button in the HackMaster list. HackMaster is not smart about the content of
 * this file; it will simply jump to the first executable statement in this
 * file. If you need helper functions, prototype them above, and define them
 * AFTER the trap patch.
 */
 
Boolean PrefsHandler(EventPtr event)
{
    FormPtr frm;
    Boolean handled=false;

    switch (event->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
        FrmDrawForm(frm);
        LoadPrefs(frm);
        handled = true;
        break;

    case frmCloseEvent:
        frm = FrmGetActiveForm();
        SavePrefs(frm);
        break;

    case ctlSelectEvent:
        switch (event->data.ctlEnter.controlID) {
        case buttonID_prefsdone:
            FrmGotoForm(9000);  /* return to HackMaster control panel */
            handled = true;
            break;
        }
        break;

    default:
        break;
    }
   
    return handled;
}

void LoadPrefs(FormPtr frm)
{
    ListPtr list;
    ControlPtr ctl;
    UInt16 prefsVersion;
    UInt16 prefsSize;
    UInt16 i, j=0;

    i = 0;
    prefsSize = sizeof(i);
    prefsVersion = PrefGetAppPreferences(MYCRID, 0 /* Pref ID */,
        &i, &prefsSize, true);

    /* translate into a list index */
    switch (i) {
    case hard1Chr: j = 0; break;
    case hard2Chr: j = 1; break;
    case hard3Chr: j = 2; break;
    case hard4Chr: j = 3; break;
    }

    list = FrmGetObjectPtr(frm,
        FrmGetObjectIndex(frm, listID_prefshotkey));
    ctl = FrmGetObjectPtr(frm,
        FrmGetObjectIndex(frm, poptrigID_prefshotkey));
    CtlSetLabel(ctl, LstGetSelectionText(list, j));
    LstSetSelection(list, j);
}

void SavePrefs(FormPtr frm)
{
    UInt16 i, j=hard1Chr;
    ListPtr list;

    list = FrmGetObjectPtr(frm,
        FrmGetObjectIndex(frm, listID_prefshotkey));
    i = LstGetSelection(list);

    /* translate into a char */
    switch (i) {
    case 0: j = hard1Chr; break;
    case 1: j = hard2Chr; break;
    case 2: j = hard3Chr; break;
    case 3: j = hard4Chr; break;
    }

    PrefSetAppPreferences(MYCRID, 0 /* Pref ID */, 1 /* Version */,
        &j, sizeof(j), true);
    /* now save to a feature for efficiency */
    FtrSet(MYCRID, FTR_HOTKEY, j);
}
